macroScript separateBySmoothingGroups 
	category:"DragAndDrop"
	toolTip:""
(
	fn exists m_arr m_val =
	(
		for m_i in m_arr do 
		(
			if m_i.v1 == m_val then
				return true
		)
		return false
	)

	fn getByIndex m_arr m_index =
	(
		for m_i in m_arr do 
		(
			if m_i.v1 == m_index then
				return m_i
		)
	)

	fn iterateTroughtFaces m_obj =
	(
		local m_smGroups = #();
		for m_face =1 to m_obj.numFaces do -- for each face in the mesh
		(
			local m_sgroupVal = polyOp.getFaceSmoothGroup m_obj m_face;
			if not exists m_smGroups m_sgroupVal then
			(
				append m_smGroups ( DataPair m_sgroupVal #( m_face ) );
			)
			else
			(
				append ( getByIndex m_smGroups m_sgroupVal ).v2 m_face;
			)
		)
		--print m_smGroups;
		return m_smGroups;
	)

	fn separateBySmoothingGroups m_obj =
	(
		local m_smGroups = iterateTroughtFaces m_obj;
		for m_i in m_smGroups do 
		(
			m_obj.selectedFaces = m_i.v2;
			local polyList = #{};
			polyList = polyOp.getFaceSelection m_obj;
			polyOp.detachFaces m_obj polyList delete:false asNode:true;
		)
		--print m_smGroups;
	)
	
	m_selectedObjs = selection as array;
	for m_obj in m_selectedObjs do
	(
		convertToPoly m_obj;
		separateBySmoothingGroups m_obj;
		delete m_obj;
	)
)
